/***16.11.09 5 Sekunden lang, danach kurz  ******************/


#include <eZ8.h>
#include <stdio.h>
volatile char c_faktor; 
volatile int i_flop_turns; 
volatile char _vola_irq_c_zz;

volatile char _c_trigg;

/**************************************/
#define OSC_UNLOCK_SEQ1 0xE7
#define OSC_UNLOCK_SEQ2 0x18 
#define clock() (PAIN & 0x80) /*Pin13*/
#define data() (PAIN & 0x40)  /*Pin12*/
/*  Anmelden   */
void watch_dog_timer_regs( char, char, char );


void TrigWatch( void )
{
  asm("WDT"); 
}

void set_watch_dog_timer_regs (void)
{ 
 watch_dog_timer_regs( 0x00,0xFF,0x10 );
}

 
/**** dont forgett #pragma interrupt */
#pragma interrupt // go over RETI  */ 
void keybord_irq (void)
{
 //IRQ1ENH &= ~(0x80);/*disable itselve*/
 //IRQ1ENL &= ~(0x80);/*disable itselve*/ 
 TrigWatch(  ); // in irq WDog-trigger continius 
_c_trigg = 1; 

 

// c_faktor = 1; 
#if 0
if (c_faktor >0 )  
 {
    c_faktor--; 
 }
 //IRQ1ENH |= 0x80; /* IRQ1_Freigabe High Prio*/
 //IRQ1ENL |= 0x80; 
#endif 
}

void keybord_init(void)
{
PAADDR   =   (0x02); // Alternate 
 PACTL   |=   ~( (0x80) | (0x40) ); 
 
PAADDR   =   (0x01);  // PA Data Dir
PACTL   |=   (0x80)| (0x40);  // Iixx-xxxx Pa80,40 as Clock-andDataInput

 PAADDR   =   (0x00); // Close-For Safty-Purpose   
 IRQSS &= ~(0x80);// SSource select PIN(13) Z8XP.F0822 20_PinDip
 IRQES &= ~(0x80);// Edge_Sel is Falling--____--- 
 
 
SET_VECTOR(PAD7_IVECT, keybord_irq);/* Call it... go over RETI  */ 
 IRQ1ENH |= 0x80; /* IRQ1_Freigabe High Prio*/
 IRQ1ENL |= 0x80; 

 }
/**** dont forgett #pragma interrupt */
#pragma interrupt // go over RETI  */ 
void timer0_irq (void)
{
  _vola_irq_c_zz--; 
}

/********19.10.09*****************************************/
void timer0_init(void)
{/* TIMER_0 TIMER_1 T0,????T1*/
// timer disabletimer() ;
 T0RH = 0x00;
 T0RL = 0x00;
 T0H  = 0x00;
 T0L  = 0x01;         /* Call it... go over RETI  */
 
}

/********************************************************/
/* Mein Makros die ich im Code verwende */

#define keyboard_timer_disable() T1CTL1 &= 0x7F
#define keyboard_timer_enable()  T1CTL1 |= 0x80
#define timeout_irq_flg() (IRQ0 & 0x40)/* Timer(01) IRq0_Flag Mask*/

/*------------------------------------------------------*/
void keyboard_timer_re_start(void)
{
 keyboard_timer_disable();/* optional */
 T1L = T1H = (0x00); /* Bounce again Zero Back , Start at Zero */
/* Parameter Scale T-Reload-Threshold -Level extern once */
/* store explicit ever .... optional */
 T1RH = 0x02;  /* 0x1000 3ms */
 T1RL = 0x00;
/* -------------------- */
 IRQ0 &= ~(0x40); /* Manuell Kill T1-IRQ flag */
 keyboard_timer_enable();
}

void keyboard_timer01_init_scale_mode(void)
{
keyboard_timer_disable();
/* Threshold-Trigger-Level */
T1RH = 0x0;  /* 0x1000 3ms */
T1RL = 0x7f; /*            */

/* Timer-1 in Single Shot Mode*/
T1CTL0 = 0x00;
T1CTL1 = 0x10;

}


void _wait(void)
{
 keyboard_timer_re_start(  );
 while( !timeout_irq_flg() );// poll T1-IRQ flag 
}

void delay_t1(void)
{
int waittime;
  waittime = 2000 *  c_faktor; //keyboard_timer_init_mode(  );
   while(waittime--)// decrement 
    {
     _wait();
    }
 }

void Init_Port_B (void)
{
  PBADDR   =   (0x01);  // PB Data Dir
  PBCTL   &=  ~(0x01);  // xxxx-xxx0 PB00 as Output
  PBCTL   |=   (0x02);  // xxxx-xxI0 PB01 as Input

  PBADDR   =   (0x06); // PB Data Dir
  PBCTL   |=   (0x02); // xxxx-xx[H-Pull]x PB_01-- Pull-Up Input

  PBADDR   =   (0x00); // Close-For Safty-Purpose
}

void Run_Timer_App (void)
{
    PBOUT |=  (0x01); // On-B0-Toggle
     delay_t1();
    PBOUT &= ~(0x01); // Off-B0-Toggle -BIT_0
     delay_t1();
}

void Init_Oszi (void)
{
 OSCCTL = OSC_UNLOCK_SEQ1; // Unlock sequence for OSCTL write
 OSCCTL = OSC_UNLOCK_SEQ2; //
//  0x80 = Bit 5 INTEN Internal Precision Oscillator Enable
//  0x20 = Bit 7 Watchdog Timer oscillator is enabled

 OSCCTL  = (0x80 | 0x20 );     
 

}
void Init_Keybrd_debounce_flop (void)
{
 //  IRQ1ENH |= 0x80; /* IRQ1_Freigabe High Prio*/
 //  IRQ1ENL |= 0x80; 
  if( c_faktor == 4)
  { 
    if( i_flop_turns >0)
      { 
         i_flop_turns--; 
      }
  
   }
   if( c_faktor == 4 && i_flop_turns == 0 )
     {
       
     //  c_faktor=1;
	//	i_flop_turns=0xF; 


   }
}


char c_mcu_status;

void get_res_purpus(void)
{
c_mcu_status = RSTSTAT;

#if 1

 if ( (c_mcu_status & 0x20) == 0x20) 
 {
    while (1)
    {  
       _c_trigg =0; // disable first 
    }; 
 }
#endif 

}

void main(void)
{
 
Init_Oszi();
i_flop_turns=0x5; 
 _c_trigg =0; // disable first 
c_faktor=4; 
Init_Port_B ();
timer0_init();
 keyboard_timer01_init_scale_mode(  );
keybord_init();
 

 get_res_purpus(); 



 set_watch_dog_timer_regs (); 

c_mcu_status = RSTSTAT;

// TrigWatch(  ); 

c_mcu_status = RSTSTAT; 

 EI(); /**** Enable Master-IRq*/

 
 while (1)
    {  
      if ((_c_trigg ==1) ) // messa
       {
         _c_trigg =0; // lock out
         
         
              c_faktor = 1; 
          
          
          
       }
      
      
      // TrigWatch(  ); 
       Run_Timer_App ();
   Init_Keybrd_debounce_flop (); 
	   
	   }
}

/* Ende des Test-Codes */



